local ffi = require 'ffi'
local lj_include = require 'lj_include'

lj_include('stddef')
lj_include('bits_types')

ffi.cdef[[
struct _IO_FILE;
typedef struct _IO_FILE FILE;
typedef struct _IO_FILE __FILE;
]]

lj_include('libio')
lj_include('stdarg')

ffi.cdef[[
typedef _G_fpos_t fpos_t;
typedef _G_fpos64_t fpos64_t;
]]

lj_include('bits_stdio_lim')

ffi.cdef[[
struct _IO_FILE *stdin;
struct _IO_FILE *stdout;
struct _IO_FILE *stderr;
int remove(const char *__filename);
int rename(const char *__old, const char *__new);
int renameat(int __oldfd, const char *__old, int __newfd,
    const char *__new);
FILE *tmpfile(void);
FILE *tmpfile64(void);
char *tmpnam(char *__s);
char *tmpnam_r(char *__s);
char *tempnam(const char *__dir, const char *__pfx);
int fclose(FILE * __stream);
int fflush(FILE * __stream);
int fflush_unlocked(FILE * __stream);
int fcloseall(void);
FILE *fopen(const char *__filename, const char *__modes);
FILE *freopen(const char *__filename,
    const char *__modes, FILE * __stream);
FILE *fopen64(const char *__filename, const char *__modes);
FILE *freopen64(const char *__filename,
    const char *__modes, FILE * __stream);
FILE *fdopen(int __fd, const char *__modes);
FILE *fopencookie(void *__magic_cookie,
    const char *__modes, _IO_cookie_io_functions_t __io_funcs);
FILE *fmemopen(void *__s, size_t __len, const char *__modes);
FILE *open_memstream(char **__bufloc, size_t * __sizeloc);
void setbuf(FILE * __stream, char *__buf);
int setvbuf(FILE * __stream, char *__buf, int __modes, size_t __n);
void setbuffer(FILE * __stream, char *__buf, size_t __size);
void setlinebuf(FILE * __stream);
int fprintf(FILE * __stream, const char *__format, ...);
int printf(const char *__format, ...);
int sprintf(char *__s, const char *__format, ...);
int vfprintf(FILE * __s, const char *__format, __gnuc_va_list __arg);
int vprintf(const char *__format, __gnuc_va_list __arg);
int vsprintf(char *__s, const char *__format, __gnuc_va_list __arg);
int snprintf(char *__s, size_t __maxlen, const char *__format, ...);
int vsnprintf(char *__s, size_t __maxlen,
    const char *__format, __gnuc_va_list __arg);
int vasprintf(char **__ptr, const char *__f, __gnuc_va_list __arg);
int __asprintf(char **__ptr, const char *__fmt, ...);
int asprintf(char **__ptr, const char *__fmt, ...);
int vdprintf(int __fd, const char *__fmt, __gnuc_va_list __arg);
int dprintf(int __fd, const char *__fmt, ...);
int fscanf(FILE * __stream, const char *__format, ...);
int scanf(const char *__format, ...);
int sscanf(const char *__s, const char *__format, ...);
int vfscanf(FILE * __s, const char *__format, __gnuc_va_list __arg);
int vscanf(const char *__format, __gnuc_va_list __arg);
int vsscanf(const char *__s, const char *__format, __gnuc_va_list __arg);
int fgetc(FILE * __stream);
int getc(FILE * __stream);
int getchar(void);
int getc_unlocked(FILE * __stream);
int getchar_unlocked(void);
int fgetc_unlocked(FILE * __stream);
int fputc(int __c, FILE * __stream);
int putc(int __c, FILE * __stream);
int putchar(int __c);
int fputc_unlocked(int __c, FILE * __stream);
int putc_unlocked(int __c, FILE * __stream);
int putchar_unlocked(int __c);
int getw(FILE * __stream);
int putw(int __w, FILE * __stream);
char *fgets(char *__s, int __n, FILE * __stream);
char *gets(char *__s);
char *fgets_unlocked(char *__s, int __n, FILE * __stream);
__ssize_t __getdelim(char **__lineptr,
    size_t * __n, int __delimiter, FILE * __stream);
__ssize_t getdelim(char **__lineptr,
    size_t * __n, int __delimiter, FILE * __stream);
__ssize_t getline(char **__lineptr, size_t * __n, FILE * __stream);
int fputs(const char *__s, FILE * __stream);
int puts(const char *__s);
int ungetc(int __c, FILE * __stream);
size_t fread(void *__ptr, size_t __size, size_t __n, FILE * __stream);
size_t fwrite(const void *__ptr, size_t __size, size_t __n, FILE * __s);
int fputs_unlocked(const char *__s, FILE * __stream);
size_t fread_unlocked(void *__ptr, size_t __size,
    size_t __n, FILE * __stream);
size_t fwrite_unlocked(const void *__ptr, size_t __size,
    size_t __n, FILE * __stream);
int fseek(FILE * __stream, long int __off, int __whence);
long int ftell(FILE * __stream);
void rewind(FILE * __stream);
int fseeko(FILE * __stream, __off_t __off, int __whence);
__off_t ftello(FILE * __stream);
int fgetpos(FILE * __stream, fpos_t * __pos);
int fsetpos(FILE * __stream, const fpos_t * __pos);
int fseeko64(FILE * __stream, __off64_t __off, int __whence);
__off64_t ftello64(FILE * __stream);
int fgetpos64(FILE * __stream, fpos64_t * __pos);
int fsetpos64(FILE * __stream, const fpos64_t * __pos);
void clearerr(FILE * __stream);
int feof(FILE * __stream);
int ferror(FILE * __stream);
void clearerr_unlocked(FILE * __stream);
int feof_unlocked(FILE * __stream);
int ferror_unlocked(FILE * __stream);
void perror(const char *__s);
]]

lj_include('bits_sys_errlist')

ffi.cdef[[
int fileno(FILE * __stream);
int fileno_unlocked(FILE * __stream);
FILE *popen(const char *__command, const char *__modes);
int pclose(FILE * __stream);
char *ctermid(char *__s);
char *cuserid(char *__s);
struct obstack;
int obstack_printf(struct obstack *__obstack, const char *__format, ...);
int obstack_vprintf(struct obstack *__obstack,
    const char *__format, __gnuc_va_list __args);
void flockfile(FILE * __stream);
int ftrylockfile(FILE * __stream);
void funlockfile(FILE * __stream);
]]

local defs = {
    SEEK_SET = '0',
    SEEK_CUR = '1',
    SEEK_END = '2',
}
local format, cdef, C = string.format, ffi.cdef, ffi.C
for sym, val in pairs(defs) do
    if not pcall(function() return C[sym] end) then
        cdef(format("enum {%s = %s};", sym, val))
    end
end

