require 'xpath'
require 'lxp/lom'

local m = {}

local xpath_list = {}

-- Function used to turn a glob of XML that's been converted to a LUA table
-- into a table of XPATHS to the leaves within the XML
function m.get_xpaths(t, current_path)
    if not current_path then
        current_path = ''
        xpath_list = {}
    end
    local attr = ''
    if t.attr and t.attr[1] then
        attr = '[@' .. t.attr[1] .. '="' .. t.attr[t.attr[1]] .. '"]'
    end
    if t.tag then
        current_path = current_path .. '/' .. t.tag .. attr
        if t[1] and type(t[1]) ~= 'table' then
            xpath_list[#xpath_list + 1] = current_path
        end
    end
    for k, v in pairs(t) do
        if type(v) == 'table' then
            m.get_xpaths(v, current_path)
        end
    end
    return xpath_list
end

return m
